package CPU.instructions;
import CPU.InstructionSet;
import CPU.DisassembledInstruction;

/**
 * The ILLEGAL instruction in all of its variants.
 * 
 * @author and Copyright (c) for my code Wolfgang Lenerz 2013-2014
 * 
 * 
 * Based on code by Tony Headford, see his licence in accompanying file.
 */
    

public class ILLEGAL implements InstructionSet
{
    @Override
    public final void register( final CPU.MC68000Cpu cpu2)
    {
        CPU.Instruction is =new  CPU.Instruction()
        {
            private CPU.MC68000Cpu cpu=cpu2;
            
            @Override
            public final void execute(int opcode,CPU.MC68000Cpu cpu)
            {
		cpu.raiseException(4);
                cpu.stopNow=-20;
            }
            
            @Override
            public DisassembledInstruction disassemble(int address, int opcode,CPU.MC68000Cpu cpu)
            {
                return new DisassembledInstruction(address, opcode, "illegal");
            }
        };
        cpu2.addInstruction(0x4afc, is);
    }
}
