/*
 * Copyright (c) W. Lenerz 2023.
 * This code is subject to the GPL, version 3 or later.
 */
package ui;

/**
 * The warnings section of the config menu in the menu bar, including item action routines.
 * 
 * @author and copyright Wolfgang Lenerz
 * @version  1.00 initial version
 */
public class WarningsMenu extends javax.swing.JMenu 
{
    
    private final inifile.IniFile inifile;
    private final MonitorGui mgui;
    private final Warnings warnings;
    
    public WarningsMenu (inifile.IniFile pinifile,MonitorGui mguip, Warnings pwarnings)
    {
        this.inifile=pinifile;
        this.mgui=mguip;
        this.warnings=pwarnings;
        initMenu();
    }
    private void initMenu()
    {
        this.setText(Localization.Texts[82]);
        this.add(makeCbox("WARN-ON-NONSTANDARD-WINDRIVE",83));
        this.add(makeCbox("WARN-ON-NONEXISTING-WINDRIVE",84));
        this.add(makeCbox("WARN-ON-WINDRIVE-FUL",85));
        this.add(makeCbox("WARN-ON-WINDRIVE-READ-ONLY",104));
        this.add(makeCbox("WARN-ON-SOUND-PROBLEM",114));
        this.add(makeCbox("WARN-ON-FLPDRIVE-READ-ONLY",122));
        this.add(makeCbox("WARN-ON-NONEXISTING-FLPDRIVE",124));

    }
    private javax.swing.JCheckBoxMenuItem makeCbox(String inif, int textIndex)
    {
        javax.swing.JCheckBoxMenuItem cbox=new javax.swing.JCheckBoxMenuItem();               
        cbox.setText(Localization.Texts[textIndex]);                  
        cbox.setSelected(inifile.getTrueOrFalse(inif));
        cbox.addActionListener((java.awt.event.ActionEvent evt) ->
        {
            javax.swing.JCheckBoxMenuItem cb = (javax.swing.JCheckBoxMenuItem) evt.getSource();
            ConfigData.setOptionAndSave(inif, cb.isSelected() ?"1":"0",this.inifile);
        });
        return cbox;
    }
}
